<?php

// QuickTalk 2.1 build:20090819

class cSection
{

// --------

var $domid=0;            // Domain id
var $domname='';         // Domain name
var $id=-1;              // Section id
var $idtitle='untitled'; // Section idtitle
var $name='untitled';    // Section name (translation)
var $descr='';           // Section descr (translation)
var $type=0;             // Type:   0=visible, 1=hidden, 2=hidden by user
var $status=0;           // Status: 0=actif,   1=closed
var $notify=1;           // Notify: 0=disable, 1=enabled
var $modid=0;            // Moderator id
var $modname='Admin';    // Moderaotr name
var $numfield='N';        // Format of the ref number: 'N' means no ref number
var $titlefield=1;       // Topic title: 0=None, 1=Optional, 2=Mandatory
//var $eventdate=0;      // Topic eventdate: 0=None, 1=Optional, 2=Mandatory, 3=Date+time (optional), 4=Date+time (mandatory)
//var $wisheddate=0;     // Topic wisheddate: 0=None, 1=Optional, 2=Mandatory
//var $notifycc=0;       // Topic alternate notify: 0=None, 1=Optional, 2=Mandatory
var $prefix='a';         // Prefix icon from the serie 'a'
var $stats='';           // Several stats
var $options='';         // Several options
// computed values
var $lastpostid=-1;
var $lastposttopic=-1;
var $lastpostdate='0';
var $lastpostuser=0;
var $lastpostname='Visitor';
// stats
var $topics=0;   // Total topics (including news)
var $replies=0;  // Total replies (type R,F or  D)
var $tags=0;     // >0 means tags exists (may be several time the same!)
var $topicsZ=0;  // Total topics closed (including news)
var $repliesZ=0; // Total replies in topics closed (type R,F or  D)
// options
var $d_order=''; // Ticket default sort order
var $d_last='';  // Last column in the topic list: 'none' means no last column
var $d_logo='';  // Ovewrite icon with an image-logo named s_x.gif/.jpeg/.jpg/.png (where x is the section id)

// -- Constructor method (accept an id, an array or a cSection as parameter) --

function cSection($aSection=null,$bLast=false)
{
  if ( isset($aSection) )
  {
    if ( is_int($aSection) )
    {
      if ( $aSection<0 ) die('No section '.$aSection);
      global $oDB;
      $oDB->Query('SELECT f.*,d.title as domtitle FROM '.TABSECTION.' f INNER JOIN '.TABDOMAIN.' d ON d.id=f.domainid WHERE f.id='.$aSection);
      $row = $oDB->Getrow();
      if ( $row===False )  die('No section '.$aSection);
      $this->MakeFromArray($row);
    }
    elseif ( is_array($aSection) )
    {
      $this->MakeFromArray($aSection);
    }
    else
    {
      die('Invalid constructor parameter #1 for the class cSection');
    }
  }

  // Read stats and options

  $this->ReadStats();
  $this->ReadOptions();

  // Find last post
  
  if ( $bLast ) $this->GetSectionLastPost();
  
  // Default sort order
  
  if ( $this->d_last=='no' || empty($this->d_last) ) $this->d_last = 'none';
  if ( empty($this->d_order) ) $this->d_order='lastpostdate';
}

// --------

function MakeFromArray($aSection)
{
  foreach($aSection as $strKey=>$oValue) {
  switch ($strKey) {
    case 'domainid':     $this->domid     = intval($oValue); break;
    case 'id':           $this->id        = intval($oValue); break;
    case 'title':        $this->idtitle   = $oValue; break;
    case 'type':         $this->type      = intval($oValue); break;
    case 'status':       $this->status    = intval($oValue); break;
    case 'stats':        $this->stats     = $oValue; break;
    case 'options':      $this->options   = $oValue; break;
    case 'notify':       $this->notify    = intval($oValue); break;
    case 'moderator':    $this->modid     = intval($oValue); break;
    case 'moderatorname':$this->modname   = $oValue; break;
    case 'numfield':     $this->numfield  = $oValue; break;
    case 'titlefield':   $this->titlefield= intval($oValue); break;
    //case 'eventdate':    $this->eventdate = intval($oValue); break;
    //case 'wisheddate':   $this->wisheddate= intval($oValue); break;
    //case 'alternate':    $this->notifycc  = intval($oValue); break;
    case 'prefix':       $this->prefix    = $oValue; break;
  }}
  $this->name = ObjTrans('sec','s'.$this->id,$this->idtitle);
  $this->descr = ObjTrans('secdesc','s'.$this->id,false);
  $this->domname= ObjTrans('domain','d'.$this->domid,'(domain '.$this->domid.')');
}

// --- [i] ---

function Add($intDom=0,$str='untitled')
{  
  DieArg( 'cSection->Add',array($intDom,$str),array('int','str') );
  if ( empty($str) ) die('cSection->Add: Argument #1 must be a string');

  // Inserts a new section

  global $oDB, $oSYS;
  $id = Nextid(TABSECTION);
  $oDB->Query( 'INSERT INTO '.TABSECTION.' (domainid,id,type,status,notify,titleorder,moderator,titlefield,title,stats,options,moderatorname,numfield,prefix) VALUES ('.$intDom.','.$id.',0,0,1,0,0,1,"'.addslashes($str).'","","coord=0;order=0;last=0;logo=0","Admin","N","a")' );
  
  // System

  if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
  $oSYS->Changed();
}

// ----------

function Delete()
{  
  if ( $this->id<1 ) die('cSection->Delete: Argument #1 must be an integer'); // section 0 cannot be deleted

  // Process
  
  global $oDB, $oSYS;
  $this->DeleteTopics();
  $oDB->Query('DELETE FROM '.TABSECTION.' WHERE id='.$this->id);
  cLang::Delete(array('sec','secdesc'),'s'.$this->id);

  // System

  if ( isset($_SESSION[QT]['sys_topics']) ) Unset($_SESSION[QT]['sys_topics']);
  if ( isset($_SESSION[QT]['sys_replies']) ) Unset($_SESSION[QT]['sys_replies']);
  if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
  $oSYS->Changed();
}

// --------

function GetLogo()
{
  if ( !empty($this->d_logo) )
  {
  if ( file_exists('upload/section/'.$this->d_logo) ) return 'upload/section/'.$this->d_logo;
  }
  return $_SESSION[QT]['skin_dir'].'/ico_section_'.$this->type.'_'.$this->status.'.gif';
}

// --------

function GetSectionLastPost()
{
  $this->lastpostid = null;
  $this->lastposttopic = null;
  $this->lastpostdate = null;
  $this->lastpostuser = null;
  $this->lastpostname = null;
  if ( $this->id<0 ) return null;
  if ( $this->topics==0 ) return null;

  global $oDB;

  // attention: this subquery requires mysql 4.1 (thus, use here two queries)
  $oDB->Query('SELECT MAX(id) as maxid FROM '.TABPOST.' WHERE forum='.$this->id);
  $row = $oDB->Getrow();
  $intIdlast = $row['maxid'];
  if ( is_numeric($intIdlast) )
  {
    $strQ = 'SELECT id,topic,issuedate,userid,username FROM '.TABPOST.' WHERE id='.$intIdlast;
    $oDB->Query($strQ);
    if ( $row=$oDB->Getrow() )
    {
    $this->lastpostid = intval($row['id']);
    $this->lastposttopic= intval($row['topic']);
    $this->lastpostdate = $row['issuedate'];
    $this->lastpostuser = intval($row['userid']);
    $this->lastpostname = $row['username'];
    }
  }
}

// --- [i] ---

function GetTagsUsed($intS=null,$intMax=20)
{
  // -1 to compute on all sections
  // maximum returned is $intMax distinct tags (from most recents active messages)
  // Allow instanciation
  
  if ( !isset($intS) ) $intS = $this->id;

  // Check

  if ( !is_int($intS) ) die('cSection->GetTagsUsed: Argument #1 must be integer');

  // Process

  $arrTags = array();  
  global $oDB;
  $oDB->Query( 'SELECT DISTINCT tags, lastpostdate FROM '.TABTOPIC.($intS==-1 ? '' : ' WHERE forum='.$intS).' ORDER BY lastpostdate DESC' );
  $i=0;
  while($row=$oDB->Getrow()) {
  if ( !empty($row['tags']) ) {

    $arr = explode(';',$row['tags']);
    foreach($arr as $str)
    {
      if ( !empty($str) ) {
      if ( !in_array($str,$arrTags) ) {
        $arrTags[$str] = $str;
        $i++;
        if ( $i>$intMax ) break;      
      }}
    }    
    if ( $i>$intMax ) break;
    
  }}
  if ( count($arrTags)>2 ) asort($arrTags);
  return $arrTags;
}

// --------

function MoveTopics($intSrc=-1,$intDest=0,$intRenum=1,$intTopic=-1,$bClosedOnly=false)
{
  if ( $intSrc<0 || $intDest<0 ) { echo 'cSection->MoveContent: Wrong source/destination id'; Return False; }
  if ( $intSrc==$intDest ) { echo 'cSection->MoveContent: Same source/destination id'; Return False; }

  global $oDB;
  
  $strTopic = '';
  $strPost = '';
  $strField = ''; if ( $intRenum==0 ) $strField = ', numid = 0';

  // if move only one topic
  if ( $intTopic>=0 )
  {
    $strTopic=" AND id=$intTopic";
    $strPost=" AND topic=$intTopic";
    if ( $intRenum==2 )
    {
    $nextnumid = Nextid(TABTOPIC,'numid','WHERE forum='.$intDest);
    $strField = ', numid='.intval($nextnumid);
    }
    $bClosedOnly=false;
  }
  else
  {
    if ( $intRenum==2 )
    {
    $nextnumid = Nextid(TABTOPIC,'numid','WHERE forum='.$intDest);
    $oDB->Query('SELECT MIN(numid) as minnumid FROM '.TABTOPIC.' WHERE forum='.$intSrc);
    $row = $oDB->Getrow();
    $minnumid = $row['minnumid'];
    $strField = ", numid = $nextnumid + (numid - $minnumid)";
    }
  }

  // update topics and posts

  if ( $bClosedOnly )
  {
    $arr = array();
    $oDB->Query('SELECT id FROM '.TABTOPIC.' WHERE forum='.$intSrc.' AND status="1" AND type="T"');
    while($row=$oDB->Getrow())
    {
      $arr[] = $row['id'];
    }
    foreach($arr as $intKey=>$intSection)
    {
    $oDB->Query('UPDATE '.TABTOPIC." SET forum=$intDest $strField WHERE id=$intSection");
    $oDB->Query('UPDATE '.TABPOST." SET forum=$intDest WHERE topic=$intSection");
    }
  }
  else
  {
    $oDB->Query( 'UPDATE '.TABTOPIC." SET forum=$intDest $strField WHERE forum=$intSrc $strTopic" );
    $oDB->Query( 'UPDATE '.TABPOST." SET forum=$intDest WHERE forum=$intSrc $strPost" );
  }

  // stats

  UpdateSectionStats($intSrc);
  UpdateSectionStats($intDest);
}

// --------

function DeleteTopics($s=-1,$bClosedOnly=false)
{
  // Check

  if ( $s<0 ) die('cSection->DeleteContent: Wrong section id [-1]');

  // Process - delete topics and posts
  
  global $oDB;
  
  if ( $bClosedOnly )
  {
    $arr = array();
    $oDB->Query('SELECT id FROM '.TABTOPIC.' WHERE forum='.$s.' AND status="1" AND type="T"');
    while($row=$oDB->Getrow())
    {
      $arr[] = $row['id'];
    }
    foreach($arr as $intKey=>$id)
    {
      $oDB->Query('DELETE FROM '.TABPOST.' WHERE topic='.$id);
      $oDB->Query('DELETE FROM '.TABTOPIC.' WHERE id='.$id);
    }
    UpdateSectionStats($s);
  }
  else
  {
    $oDB->Query('DELETE FROM '.TABPOST.' WHERE forum='.$s);
    $oDB->Query('DELETE FROM '.TABTOPIC.' WHERE forum='.$s);
    $oDB->Query('UPDATE '.TABSECTION.' SET topics=0, replies=0 WHERE id='.$s);
  }
  // Update section stats
  UpdateSectionStats($s);
}

// --------

function Count($str='topics',$intS=null,$d=10)
{
  // Allow instanciation
  
  if ( !isset($intS) ) $intS = $this->id;

  // Check
  if ( $intS<0 )
  {
    echo get_class($this).'->CountNews: Wrong section id -1';
    Return False;
  }

  // Process
  
  global $oDB;

  switch($str)
  {
  case 'topics': $oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC.' WHERE forum='.$intS); break;
  case 'news':   $oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC.' WHERE forum='.$intS.' AND type="A"'); break;
  case 'closed': $oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC.' WHERE status="1" AND forum='.$intS.' AND type="T"'); break;
  case 'unreplied':
    if ( $d<1 ) die('Wrong day in section->CountUnreplies');
    $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE forum='.$intS.' AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$d,'day').'"' );
    break;
  case 'unrepliednews':
    if ( $d<1 ) die('Wrong day in section->CountUnreplies');
    $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE forum='.$intS.' AND type="A" AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$d,'day').'"' );
    break;
  default: return 0;
  }
  //return value
  $row = $oDB->Getrow();
  return intval($row['countid']);
}

// --------

function ReadOptions()
{
  $arr = ReadValues($this->options);
  if ( isset($arr['order']) ) $this->d_order = $arr['order'];
  if ( isset($arr['last']) ) $this->d_last = $arr['last'];
  if ( isset($arr['logo']) ) $this->d_logo = $arr['logo']; 
}

// --------

function ReadStats()
{
  $arr = ReadValues($this->stats);
  if ( isset($arr['topics']) ) $this->topics = $arr['topics'];
  if ( isset($arr['replies']) ) $this->replies = $arr['replies'];
  if ( isset($arr['tags']) ) $this->tags = $arr['tags'];
  if ( isset($arr['topicsZ']) ) $this->topicsZ = $arr['topicsZ'];
  if ( isset($arr['repliesZ']) ) $this->repliesZ = $arr['repliesZ'];
}

// --------

}

?>