<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @category   Forum
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.1 build:20090819
* @since      File available since Release 1.0.0
* @deprecated File deprecated in Release 3.0.0
*/

session_start();
require_once('bin/qtf_init.php');
if ( !$oVIP->CanView('V5') ) HtmlPage(11);

// CHANGE USER INTERFACE

if (isset($_GET['view'])) $_SESSION[QT]['viewmode'] = substr($_GET['view'],0,1);

// INITIALISE

include('bin/qtf_fn_sql.php');

// Protection against injection: 'order','group','dir' are controlled
$strGroup = 'all';
$strOrder = 'name';
$strDirec = 'ASC';
$intLimit = 0;
$intPage  = 1;
if ( isset($_GET['group']) ) { $strGroup = substr($_GET['group'],0,3); } // protection against injection
if ( isset($_GET['page']) )  { $intLimit = (intval($_GET['page'])-1)*$_SESSION[QT]['topics_per_page']; $intPage = intval($_GET['page']); }
if ( isset($_GET['order']) ) { $strOrder = strip_tags(substr($_GET['order'],0,15)); } // protection against injection
if ( isset($_GET['dir']) )   { if ( $_GET['dir']=='DESC' ) $strDirec = 'DESC'; }      // protection against injection

$oVIP->selfurl = 'qtf_members.php';
$oVIP->selfname = $L['Memberlist'];

// MAP MODULE

if ( UseModule('map') ) { $bCheckList=true; include('qtfm_map_ini.php'); } else { $bMap=false; }

// COUNT

Switch ($strGroup)
{
Case 'all': $where = ' WHERE id>0'; Break;
Case '#':   $where = ' WHERE id>0 AND '.FirstCharCase('name','a-z'); Break;
Default:    $where = ' WHERE id>0 AND '.FirstCharCase('name','u').'="'.$strGroup.'"'; Break;
}

if ($strGroup=='all')
{
$intCount = $_SESSION[QT]['sys_members'];
}
else
{
$oDB->Query('SELECT count(id) as countid FROM '.TABUSER.$where);
$row = $oDB->Getrow();
$intCount = $row['countid'];
}

// GROUP LINE

if ( $intCount>$_SESSION[QT]['topics_per_page'] || isset($_GET['group']) ) $strGroups = HtmlLettres($strGroup,$L['All']);

// --------
// HTML START
// --------

$bJava=true;
include('qtf_p_header.php');

// --------
// Title and top 5
// --------

// header

echo '<table class="hidden" cellspacing="0">',N;
echo '<tr class="hidden">',N;
echo '<td class="hidden"><h2>',$oVIP->selfname,'</h2><p>',( $strGroup=='all' ? $_SESSION[QT]['sys_members'].' '.$L['Members'] : $intCount.' / '.$_SESSION[QT]['sys_members'].' '.$L['Members'] );
if ( CanPerform("show_calendar",$oVIP->role) ) 
{
echo '&nbsp;&middot;&nbsp;<a href="qtf_calendar.php',(empty($row['birthday']) ? '' : '?m='.substr($row['birthday'],4,2)),'">',$L['Birthdays_calendar'],'</a>';
}
echo '</p></td>',N;
echo '<td class="hidden" style="width:170px;">',N;
echo '<div class="legendbox">',N;
echo '<p class="legendtitle">',$L['Top_participants'],'</p>',N;
echo '<table class="hidden" cellspacing="0">',N;

//-- LIMIT QUERY --
$strState = 'name, id, numpost FROM '.TABUSER.' WHERE id>0';
$oDB->Query( LimitSQL($strState,'numpost DESC',0,5) );
// --------

For ($i=0;$i<($_SESSION[QT]['viewmode']=='C' ? 2 : 5);$i++)
{
$row = $oDB->Getrow();
if (!$row) break;
echo '<tr><td style="text-align:left"><a href="qtf_usr.php?id=',$row['id'],'">',$row['name'],'</a></td><td style="text-align:right">',$row['numpost'],'</td></tr>',N;
}
echo '</table>',N,'</div>',N;
echo '</td>',N;
echo '</tr>',N;
echo '</table>',N,N;

// --------
// Button line and pager
// --------

// -- build pager --

$strPager = MakePager("qtf_members.php?group=$strGroup&order=$strOrder&dir=$strDirec",$intCount,$_SESSION[QT]['topics_per_page'],$intPage);
if ( !empty($strPager) ) $strPager = $L['Page'].$strPager;
if ( $intCount<$_SESSION[QT]['sys_members'] ) $strPager = '<span class="small">'.$intCount.' '.$L['Selected_from'].' '.$_SESSION[QT]['sys_members'].' '.strtolower($L['Users']).'</span>'.(empty($strPager) ? '' : ' | '.$strPager);

// -- Display button line (if more that tpp users) and pager --

if ($_SESSION[QT]['sys_members']>$_SESSION[QT]['topics_per_page']) echo '<table class="button" cellspacing="0"><tr class="button">',$strGroups,'</tr></table>',N;

if ( !empty($strPager) )
{
echo '<table class="hidden" cellspacing="0"><tr class="hidden"><td class="hidden" id="pager_zt">',$strPager,'</td></tr></table>',N,N;
}

// end if no result
if ($intCount==0)
{
  echo '<p>',$L['None'],'</p><br/>';
  include('qtf_p_footer.php');
  exit;
}

// --------
// Memberlist
// --------

$bCompact = FALSE;
if ( $_SESSION[QT]['avatar']=='0' ) $bCompact = true;
if ( $_SESSION[QT]['viewmode']=='C' ) $bCompact = true;

echo '<table class="data_t" cellspacing="0">',N;
echo '<tr class="data_t">',N;

// ========
$arrFLD = array();
if ( $bCompact )
{
$oFLD = new cFLD('name',$L['Username']);    $oFLD->sort='ASC'; $oFLD->desc='class=th_t th_t_usr th_t_first;style=width:150px'; $arrFLD['name']=$oFLD;
}
else
{
$oFLD = new cFLD('picture',$L['Avatar']);   $oFLD->sort=FALSE; $oFLD->desc='class=th_t th_t_sta th_t_first;style=width:150px'; $arrFLD['picture']=$oFLD;
$oFLD = new cFLD('name',$L['Username']);    $oFLD->sort='ASC'; $oFLD->desc='class=th_t th_t_usr'; $arrFLD['name']=$oFLD;
}
$oFLD = new cFLD('role',$L['Role']);        $oFLD->sort='ASC'; $oFLD->desc='class=th_t th_t_sta'; $arrFLD['role']=$oFLD;
$oFLD = new cFLD('contact',$L['Contact']);  $oFLD->sort=FALSE; $oFLD->desc='class=th_t th_t_inf'; $arrFLD['contact']=$oFLD;
$oFLD = new cFLD('location',$L['Location']);$oFLD->sort='ASC'; $oFLD->desc='class=th_t th_t_inf'; $arrFLD['location']=$oFLD;
$oFLD = new cFLD('numpost',$L['Messages']); $oFLD->sort='DESC';$oFLD->desc='class=th_t th_t_sta th_t_last'; $arrFLD['numpost']=$oFLD;
// ========
TableHeader($arrFLD,$intCount,"$oVIP->selfurl?group=$strGroup&amp;page=1",$strOrder,$strDirec);
// ========

echo '</tr>',N;

foreach($arrFLD as $strKey=>$oFLD) if ( !empty($oFLD->desc) ) { $oFLD->desc = str_replace('th_','td_',$oFLD->desc); $arrFLD[$strKey]=$oFLD; }
// ========
$strState = '* FROM '.TABUSER.$where;
$oDB->Query( LimitSQL($strState,$strOrder.' '.$strDirec,$intLimit,$_SESSION[QT]['topics_per_page'],$intCount) );
// ========
$intWhile=0;
$strAlt='r1';
while($row=$oDB->Getrow())
{
  // privacy control for map and location field
  if ( $oVIP->IsPrivate($row['privacy'],$row['id']) ) { $row['y']=null; $row['x']=null; }

  TableRow($arrFLD,$row,false,null,$strAlt,$bMap);
  if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }

  // map settings
  if ( $bMap ) {
  if ( !empty($row['x']) && !empty($row['y']) ) {
    $str = $row['name'].'<br/><br/><a class="gmap" href="qtf_usr.php?id='.$row['id'].'">Open profile &raquo;</a>';
    if ( !empty($row['picture']) ) 
    {
    $str = '<table class="gmap"><tr><td>'.AsImg(QTF_DIR_PIC.$row['picture'],'',$row['name'],'imagelist').'</td><td>'.$str.'</td></tr></table>';
    }
    $oMapPoint = new cMapPoint( floatval($row['y']),floatval($row['x']),QTconv($row['name'],'-4'),$str );
    if ( isset($_SESSION[QT]['m_map_gsymbol']) )
    {
    $oMapPoint->icon = QTgetsymbol($row['role'],'icon');
    $oMapPoint->shadow = QTgetsymbol($row['role'],'shadow');
    $oMapPoint->printicon = QTgetsymbol($row['role'],'printicon');
    $oMapPoint->printshadow = QTgetsymbol($row['role'],'printshadow');
    }
    $arrExtData[intval($row['id'])] = $oMapPoint;
  }}
  $intWhile++; 
  //odbcbreak
  if ( $intWhile>=$_SESSION[QT]['topics_per_page'] ) break;  
}
// ========

echo '<tr class="data_t">',N;
echo '<td class="tf_t tf_t_first"></td>',N;
For ($i=0;$i<(count($arrFLD)-2);$i++)
{
echo '<td class="tf_t"></td>',N;
}
echo '<td class="tf_t tf_t_last"></td>
</tr>
</table>
';

// -- Display pager --

if ( !empty($strPager) )
{
echo '<table class="hidden" cellspacing="0"><tr class="hidden"><td class="hidden" id="pager_zb">',$strPager,'</td></tr></table>',N,N;
}

// MAP MODULE, Show map

if ( $bMap )
{
  echo '<!-- Map module -->',N;
  if ( count($arrExtData)>0 )
  {
    $strMapHelp = sprintf( $L['map']['items'],strtolower(LangS('Member',count($arrExtData))),strtolower(LangS('Member',$oSYS->members)) );

    echo '<table class="hidden" style="margin-top:5px;">',N;
    echo '<tr class="hidden">',N;
    echo '<td class="gmap">',N;
    if ( !$_SESSION[QT]['m_map_hidelist'] )
    {
    echo QTgmapZoomControl($arrExtData);
    echo '<div id="map_canvas" style="width:100%; height:',($_SESSION[QT]['viewmode']=='C' ? '350' : '400'),'px;"></div>',N;
    }
    if ( !empty($strMapHelp) ) echo '<p class="gmap" style="margin:4px 0 0 0">'.$strMapHelp.'</span>';
    echo '</td>',N;
    echo '</tr>',N;
    echo '</table>',N;

    // Show/Hide

    if ( $_SESSION[QT]['m_map_hidelist'] ) 
    {
    echo '<p style="margin:2px"><a href="',$oVIP->selfurl,'?showmap">',$L['map']['Show_map'],'</a></p>',N;
    }
    else
    {
    echo '<p style="margin:2px"><a href="',$oVIP->selfurl,'?hidemap">',$L['map']['Hide_map'],'</a></p>',N;
    }
  }
  else
  {
    echo '<p class="gmap">'.$L['map']['E_noposition'].'</p>',N;
  }
  echo '<!-- Map module end -->',N;
}

// --------
// HTML END
// --------

// MAP MODULE

if ( $bMap )
{
  if ( count($arrExtData)>0 ) { include('qtfm_map_load.php'); } else { echo '<script type="text/javascript">function GUnload() { return true; }</script>'; }
}

include('qtf_p_footer.php');

?>