<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @category   Forum
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.1 build:20090819
* @since      File available since Release 1.0.0
* @deprecated File deprecated in Release 3.0.0
*/

session_start();
require_once('bin/qtf_init.php');
$oSYS->output='print';
if ( !$oVIP->CanView('V2') ) HtmlPage(11);

$s = -1;
if ( isset($_GET['s']) ) $s = intval(strip_tags($_GET['s']));
if ( isset($_POST['s']) ) $s = intval(strip_tags($_POST['s']));
if ( $s<0 ) die('Missing section id...');

// ---------
// INITIALISE
// ---------

include('bin/qtf_fn_sql.php');

$oSEC = new cSection($s);

if ( $oSEC->type==1 && ($oVIP->role=='V' || $oVIP->role=='U') )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,$L['R_staff'],$_SESSION[QT]['skin_dir'],0);
}
if ( $oSEC->type==2 && $oVIP->role=='V' )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,$L['R_member'],$_SESSION[QT]['skin_dir'],0);
}

$oVIP->selfurl = 'qtf_topics.php';
$oVIP->selfname = $L['Section'].': '.$oSEC->name;

$strCommand = '';
$arrMe[] = array();

// Protection against injection: order and dir are controlled
$strOrder = 'lastpostdate';
$strDirec = 'DESC';
$intPage  = 1;
$intLimit = 0;
if (isset($_GET['page']))  { $intLimit = (intval($_GET['page'])-1)*$_SESSION[QT]['topics_per_page']; $intPage = intval($_GET['page']); }
if (isset($_GET['order'])) { $strOrder = strip_tags(substr($_GET['order'],0,15)); } // protection against injection
if (isset($_GET['dir']))   { if ( $_GET['dir']=='ASC' ) $strDirec = 'ASC'; }        // protection against injection

// --------
// HTML START
// --------

include('qtf_p_header.php');

echo '
<h2>',$oSEC->name,'</h2>
';

// SECTION OPTIONS

$byuser = '';
if ( ($oSEC->type==2) && ($oVIP->role!='M') && ( $oVIP->role!='A' )) $byuser = "AND t.firstpostuser={$oVIP->id}";

$strShowclosed = '';
if ( $_SESSION[QT]['show_closed']=='0' ) $strShowclosed='AND t.status="0"';

// BUTTON LINE AND PAGER

$oDB->Query('SELECT count(*) as countid FROM '.TABTOPIC." t WHERE t.forum={$oSEC->id} $strShowclosed ".$byuser);
$row = $oDB->Getrow();
$intCount = $row['countid'];
$strPager = MakePager("$oVIP->selfurl?s={$oSEC->id}",$intCount,$_SESSION[QT]['topics_per_page'],$intPage);
if ($strPager!='') $strPager = $L['Page'].$strPager;


if ( $_SESSION[QT]['section_desc']=='1' )
{
  if ( !empty($oSEC->descr) ) echo '<!-- Section description -->',N,'<p id="sectiondesc">',$oSEC->descr,'</p>',N,'<!-- Section description -->',N,N;
}

echo '
<!-- Button and pager -->
<table class="button button_top" cellspacing="0">
<tr class="button">
<td id="pager_zt">',$strPager,'</td>
</tr>
</table>
<!-- End button and pager -->
';

// DISPLAY

if ( $intCount==0 )
{
  echo "<br/>{$L['None']}... {$L['E_topic_private']}<br/><br/>\n";
  include('qtf_p_footer.php');
  exit;
}

// LIST TOPICS

$strExtra = $oSEC->d_last; // can be "none" (moderator requests no-field)
if ( !empty($_SESSION[QT]['lastcolumn']) ) $strExtra = $_SESSION[QT]['lastcolumn'];
switch($strExtra)
{
case 'views': $str=$L['Views']; break;
case 'status': $str=$L['Status']; break;
case 'tags': $str=$L['Tags']; break;
default: $str=$strExtra;
}

echo '<table class="data_t" cellspacing="0">',N;
echo '<tr class="data_t">',N;

// ========
$arrFLD = array();
$oFLD = new cFLD('icon','&nbsp;');      $oFLD->desc='class=th_t th_t_ico th_t_first'; $arrFLD['icon']=$oFLD;
if ( $oSEC->numfield!='N' )
{
$oFLD = new cFLD('numid',$L['Ref']);    $oFLD->desc='class=th_t th_t_ref'; $arrFLD['numid']=$oFLD;
}
if ( !empty($oSEC->prefix) )
{
$oFLD = new cFLD('smile','&nbsp;');     $oFLD->desc='class=th_t th_t_smi'; $arrFLD['smile']=$oFLD;
}
$oFLD = new cFLD('title',$L['Topics']); $oFLD->desc='class=th_t th_t_tit'; $arrFLD['title']=$oFLD;
if ( QTF_LIST_ME )
{
$oFLD = new cFLD('you','&nbsp;');       $oFLD->desc='class=th_t th_t_inf;style=width:10px'; $arrFLD['you']=$oFLD;
}
$oFLD = new cFLD('firstpostname',$L['Topic_starter']); $oFLD->desc='class=th_t th_t_inf;style=width:140px'; $arrFLD['firstpostname']=$oFLD;
$oFLD = new cFLD('lastpostdate',$L['Last_message']);   $oFLD->desc='class=th_t th_t_inf;style=width:140px'; $arrFLD['lastpostdate']=$oFLD;
if ( $strExtra=='none' || empty($strExtra) || $strExtra=='replies' )
{
$oFLD = new cFLD('replies',$L['Replys']); $oFLD->desc='class=th_t th_t_sta th_t_last;style=width:75px'; $arrFLD['replies']=$oFLD;
}
else
{
$oFLD = new cFLD('replies',$L['Replys']);  $oFLD->desc='class=th_t th_t_sta;style=width:75px'; $arrFLD['replies']=$oFLD;
$oFLD = new cFLD($strExtra,$str);$oFLD->desc='class=th_t th_t_sta th_t_last;style=width:80px'; $arrFLD[$strExtra]=$oFLD;
}
// ========
TableHeader($arrFLD,$intCount,"$oVIP->selfurl?s=$oSEC->id&amp;page=1",$strOrder,$strDirec);
// ========

echo '</tr>',N;

foreach($arrFLD as $strKey=>$oFLD) if ( !empty($oFLD->desc) ) { $oFLD->desc = str_replace('th_','td_',$oFLD->desc); $arrFLD[$strKey]=$oFLD; }
// ========
if ( QTF_LIST_ME && $oVIP->numpost>0 ) {
if ( $oSEC->replies>0 ) {
  $oDB->Query('SELECT topic,issuedate FROM '.TABPOST.' WHERE forum='.$s.' AND type="R" AND userid='.$oVIP->id);
  while($row=$oDB->Getrow()) $arrMe[intval($row['topic'])] = $row['issuedate'];
}}
// ========
$strState  = 't.*, p.title, p.icon, p.textmsg FROM '.TABTOPIC.' t INNER JOIN '.TABPOST." p ON t.firstpostid=p.id WHERE t.forum = {$oSEC->id} $strShowclosed $byuser ";
if ( $strOrder=='title' ) { $strOrder='p.title'; } else { $strOrder='t.'.$strOrder; }
if ( $_SESSION[QT]['news_on_top']==1 ) $strOrder = 't.type ASC, '.$strOrder;
$oDB->Query( LimitSQL($strState,$strOrder.' '.$strDirec,$intLimit,$_SESSION[QT]['topics_per_page'],$intCount) );
// ========
$intWhile=0;
$strAlt='r1';
while($row=$oDB->Getrow())
{
  TableRow($arrFLD,$row,true,$oSEC,$strAlt);
  if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }
  $intWhile++; 
  //odbcbreak
  if ( $intWhile>=$_SESSION[QT]['topics_per_page'] ) break;  
}
// ========

echo '<tr class="tf_t">',N;
echo '<td class="tf_t tf_t_first"></td>',N;
For ($i=0;$i<(count($arrFLD)-2);$i++)
{
echo '<td class="tf_t"></td>',N;
}
echo '<td class="tf_t tf_t_last"></td>',N;
echo '</tr>',N;

echo '</table>',N,N;

// BUTTON LINE AND PAGER

if ( $intCount>2 )
{
echo '
<!-- Button and pager -->
<table class="button button_bot" cellspacing="0">
<tr class="button">
<td id="pager_zb">',$strPager,'</td>
</tr>
</table>
<!-- End button and pager -->
';
}

// TAGS FILTRING

if ( QTF_LIST_TAG && !empty($_SESSION[QT]['tags']) )
{
  require_once('bin/qtf_fn_tags.php');
  $arrTags = $oSEC->GetTagsUsed($s,50);
  if ( count($arrTags)>0 ) 
  {
      echo '<div class="tags">',$L['Tags'],': ';
      foreach($arrTags as $strTag)
      {
        if ( !empty($strTag) ) echo $strTag,'&nbsp; ';
      }  
      echo '</div>';
  }
}

// HTML END

include('qtf_p_footer.php');

?>